<!DOCTYPE html>

<?php
/****************************************************************
 	PGN2MYSQL
	version 0.1
	09 mars 2012
	Gilles G. Jobin
	Vous pouvez utiliser librement ce script
	 la condition de citer le crateur original.
	
	Pour toutes questions, me joindre au 
	jobin.gilles@gmail.com
	
	La fichier SQL accompagnateur permet de crer
	la table avec plusieurs champs qui correspondent
	aux caractristiques gnralement trouves
	dans un fichier PGN classique.
******************************************************************/
?>


<html>
<head>
	<meta charset="ISO8859-1">
	<title> ======== pgn2Mysql version 0.1 par G. G. Jobin =========</title>
	
	<!-- Date: 2012-03-09 -->
</head>
<body>

<?php

mysql_connect("localhost","root","");
mysql_select_db("pgn");

$MyTable = "parties";

/*****************************
$ROW est une tableau pour 
connatre tous les champs dj
prsents dans ma table.
Ainsi, je saurai si je dois en ajouter.
*******************************/

$result = mysql_query("SHOW COLUMNS FROM $MyTable");
if (!$result) {
   echo 'Impossible d\'excuter la requte : ' . mysql_error();
   exit;
}
if (mysql_num_rows($result) > 0) {
   while ($row = mysql_fetch_assoc($result)) {
	//$ROW contient tous les champs actuels de la table
      $ROW[] = $row[Field];
   }
}


//Nom du fichier pgn  analyser et dcoder
//Les fichiers sont dposs dans un sous dossier pgn.
//Dans cette version d PGN2MYSQL, on doit changer
//manuellement le nom du fichier.
//Dans une prochaine version, je m'arrangerai 
//pour pouvoir LIRE le dossier PGN,
//et comparer les fichiers prsents avec ceux de la bdd,
//et offrir  l'utilisateur la possibilit de les ajouter
// la base...

		$Fic ="Tartakower.pgn";
		$fp = fopen("pgn/".$Fic,"r") or die("impossible d'ouvrir le fichier");

//On lit chaque ligne du fichier, et on les met dans un tableau $lines.

		while (!feof($fp)) {

			       $lines[] = fgets($fp, 9096);
			   }
		
// Fermeture du fichier pgn. On va maintenant traiter le tableau $lines.		
		fclose($fp);

	// La variable $M me permet de contrler si
	// je suis en train de lire une partie ($m=1)
	// Si c'est le cas, c'est que j'ai dj entam la lecture 
	// de la section caractristique : valeur de la partie.
	// Si je suis en train de commencer la lecture
	// d'une nouvelle partie, je pose cette variable  0.
	
	$game = 0;
	$M=0;
	
// $alter est un tableau qui va contenir les caractristiques 
// qui ne sont pas encore des champs MySql.
	
	$alter = array();

	for ($j=0; $j < count($lines); $j++)
	{
		
		$ph = $lines[$j];
			
		// Si la ligne n'est pas vide ...
		
		if ($ph !="") 
		{
				
				/*
				La logique est la suivante.
				Si la ligne contient un crochet ouvert suivi de caractres et d'une espace
				alors on sait que nous sommes dans une caractristique (un champs) et une valeur du genre
				[Black "Jobin,G"]
				
				*/
				
				if (preg_match("/\[(.*?) /", $ph, $matches)) 
				{
					// Si $M=0, alors j'entame le dcodage d'une nouvelle partie.
					// Auquel cas je mets $M=1 pour signifier que 
					// je suis EN TRAIN de lire une partie.
					
					if ($M==0) {$game++;$M=1;$C=0;}
					$champs[$game][$C] = $matches[1];
					
					//Est-ce un champs dans la table. Sinon, on l'affiche.
					
					if (!in_array($matches[1],$ROW) AND !in_array($matches[1],$alter) ) {
						echo "ALTER TABLE $MyTable ADD $matches[1] VARCHAR(30);"."<br />";
						$alter[]=$matches[1];
					}
					
					/*
					Puisque nous avons trouv une caractristique (un champs valide)
					on trouve maintenant sa valeur.
					Il suffit de trouver tout ce qui est entre guillements anglais
					dans la ligne en question.
					*/
					
					if (preg_match("/\"(.*?)\"/", $ph, $matches)) 
					{
						
						$valeur[$game][$C] = $matches[1];
						
					}
					$C++;
				}
		
				//et si nous nous trouvons dans une ligne
				//qui ne contient pas de crochet ouvert, on sait
				//que nous sommes dans les coups de la partie.
				//je les mets dans un tableau $moves.
				// NOTEZ BIEN que, dans certains fichiers PGN
				// j'ai trouv des [ ] dans les coups de la partie.
				// Dans ce cas, PGN2MYSQL suggrera d'en faire un champs
				// ce qui est, videmment,  dconseiller.
				// Il faut donc MANUELLEMENT corriger le fichier PGN
				// Avant de poursuivre son intgration dans la BDD.
				
				else
				{
					//je remets la variable $M  zro, car
					// je sais que si la prochaine ligne contient
					// un crochet ouvert, alors je lirai
					// un NOUVELLE partie.
					$M=0;
					$moves[$game].=" ".$ph;
										
				}
	
		}
	}

// on continue avec le script si et seulement si
// aucune nouvelle caractristique n'a t trouve.

if (count($alter)==0) {

	echo "On insre les parties dans la base de donnes. Patience !<br />";

	for($g=1;$g<=$game;$g++)
		{
			
			$CHA=implode($champs[$g],',');
			$CHA .= ", moves";
			
			$VAL=implode($valeur[$g],'","');
			$VAL.="\",\"".addslashes($moves[$g]);
			$SQL="insert into $MyTable ($CHA) values (\"$VAL\")";
			
			mysql_query($SQL) or die(mysql_error());
			
			
		}

		$UPD = "update $MyTable set fichier=\"$Fic\" where fichier=''";
		mysql_query($UPD) or die(mysql_error());
		echo $g . " parties provenant du fichier $Fic ont t ajoutes.";
}
else {
	echo "Prire de modifier votre base de donnes en ajoutant les champs ci-haut !<br />Relancez ensuite l'application. Merci !<br />";
}


//quelques requtes utiles ventuellement
//SELECT distinct(fichier),count(*) FROM collectionPGN group by fichier;
//SELECT distinct(ECO),count(*) FROM collectionPGN group by ECO;
	?>
</body>
</html>
